/******************************************************************************
 * PossibleMove.java - Describe one possible move.
 * $Id: PossibleMove.java,v 1.2 2011/05/30 05:29:21 dick Exp $
 * 
 * jIBS - A Java clone of FIBS
 * Copyright 2002 - Axel Leucht
 * Copyright 2011 - Dick Balaska - BuckoSoft, Corp.
 * 
 * $Log: PossibleMove.java,v $
 * Revision 1.2  2011/05/30 05:29:21  dick
 * retab.
 *
 */

/* 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Original Code is jIBS, <https://sourceforge.net/projects/fibs/>.
 * The Initial Developer of the Original Code is Axel Leucht.
 * 
 */
package net.sourceforge.jibs.backgammon;

/** Describe one possible move.
*
* @author Axel Leucht
* @author Dick Balaska
* @version $Revision: 1.2 $ <br> $Date: 2011/05/30 05:29:21 $
* @see <a href="http://cvs.buckosoft.com/Projects/jIBS/jIBS/src/main/java/net/sourceforge/jibs/backgammon/PossibleMove.java">cvs PossibleMove.java</a>
*/
public class PossibleMove {
    private Move[] move;
    private int nrmove;

    public PossibleMove() {
        nrmove = -1;
        move = new Move[4];
        move[0] = null;
        move[1] = null;
        move[2] = null;
        move[3] = null;
    }

    public PossibleMove(PossibleMove pmv) {
        this.nrmove = pmv.nrmove;
        this.move = new Move[4];

        for (int i = 0; i < 4; i++) {
            this.move[i] = pmv.move[i];
        }
    }

    public void add(Move mv) {
        nrmove++;
        move[nrmove] = mv;
    }

    public String conv2MoveString() {
        StringBuffer buffer = new StringBuffer();

        for (int i = 0; i <= nrmove; i++) {
            if (move[i] != null) {
                if ((move[i].source <= 0) || (move[i].source >= 25)) {
                    buffer.append("bar");
                } else {
                    buffer.append(move[i].source);
                }

                buffer.append("-");

                if ((move[i].destination <= 0) || (move[i].destination >= 25)) {
                    buffer.append("off");
                } else {
                    buffer.append(move[i].destination);
                }

                buffer.append(" ");
            }
        }

        return buffer.toString();
    }

    public Move getMove(int index) {
        return move[index];
    }

    public int getnrMoves() {
        return nrmove;
    }

    public String toString() {
        return conv2MoveString();
    }
}
