/******************************************************************************
 * Leave_Command - Tell the client about jIBS.
 * $Id: Leave_Command.java,v 1.2 2011/05/31 13:02:43 dick Exp $
 * 
 * jIBS - A Java clone of FIBS
 * Copyright 2002 - Axel Leucht
 * Copyright 2011 - Dick Balaska - BuckoSoft, Corp.
 * 
 * $Log: Leave_Command.java,v $
 * Revision 1.2  2011/05/31 13:02:43  dick
 * Bucko headers.
 *
 */

/* 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Original Code is jIBS, <https://sourceforge.net/projects/fibs/>.
 * The Initial Developer of the Original Code is Axel Leucht.
 * 
 */
package net.sourceforge.jibs.command;

import net.sourceforge.jibs.backgammon.BackgammonBoard;
import net.sourceforge.jibs.backgammon.JibsGame;
import net.sourceforge.jibs.gui.JibsMessages;
import net.sourceforge.jibs.gui.JibsTextArea;
import net.sourceforge.jibs.server.JibsServer;
import net.sourceforge.jibs.server.Player;
import net.sourceforge.jibs.util.JibsWriter;

/** A Player leaves the match.
 *
 * @author Axel Leucht
 * @author Dick Balaska
 * @version $Revision: 1.2 $ <br> $Date: 2011/05/31 13:02:43 $
 * @see <a href="http://cvs.buckosoft.com/Projects/jIBS/jIBS/src/main/java/net/sourceforge/jibs/command/Leave_Command.java">cvs Leave_Command.java</a>
 */
public class Leave_Command implements JibsCommand {
	public boolean execute(JibsServer jibsServer, Player player,
			String strArgs, String[] args) {
		JibsWriter out = player.getOutputStream();
		JibsMessages jibsMessages = jibsServer.getJibsMessages();
		String msg = null;
		JibsGame game = player.getGame();

		if (game == null) {
			msg = jibsMessages.convert("m_leave_error");
			out.println(msg);
		} else {
			BackgammonBoard board = game.getBackgammonBoard();
			msg = jibsMessages.convert("m_leave");
			out.println(msg);

			Player opponent = board.getOpponent(player);
			JibsWriter outOpponent = opponent.getOutputStream();
			Object[] obj = { player.getName() };

			msg = jibsMessages.convert("m_other_leave", obj);
			JibsTextArea.log(jibsServer, msg, true);
			outOpponent.println(msg);
			game.save();
		}

		return true;
	}
}
