/******************************************************************************
 * Login_Command - Handle logging in.
 * $Id: Login_Command.java,v 1.2 2011/05/31 13:02:43 dick Exp $
 * 
 * jIBS - A Java clone of FIBS
 * Copyright 2002 - Axel Leucht
 * Copyright 2011 - Dick Balaska - BuckoSoft, Corp.
 * 
 * $Log: Login_Command.java,v $
 * Revision 1.2  2011/05/31 13:02:43  dick
 * Bucko headers.
 *
 */

/* 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Original Code is jIBS, <https://sourceforge.net/projects/fibs/>.
 * The Initial Developer of the Original Code is Axel Leucht.
 * 
 */
package net.sourceforge.jibs.command;

import net.sourceforge.jibs.gui.JibsTextArea;
import net.sourceforge.jibs.server.JibsServer;
import net.sourceforge.jibs.server.Player;
import net.sourceforge.jibs.server.Server;
import net.sourceforge.jibs.util.JibsWriter;

import java.io.BufferedReader;
import java.io.IOException;

import java.net.Socket;

import java.sql.Connection;

import java.util.StringTokenizer;

/**
 * The Login_Command will be invoked by jIBS when a user tries to login. Though
 * it adheres to the JibsCommand interface, normal processing is done by jIBS in
 * a different way.
 */
/** The Login_Command will be invoked by jIBS when a user tries to login. Though
 * it adheres to the JibsCommand interface, normal processing is done by jIBS in
 * a different way.
 *
 * @author Axel Leucht
 * @author Dick Balaska
 * @version $Revision: 1.2 $ <br> $Date: 2011/05/31 13:02:43 $
 * @see <a href="http://cvs.buckosoft.com/Projects/jIBS/jIBS/src/main/java/net/sourceforge/jibs/command/Login_Command.java">cvs Login_Command.java</a>
 */
public class Login_Command implements JibsCommand {
	public Player login(JibsServer jibsServer, Server server, Socket client,
			JibsWriter out, JibsTextArea fta, Connection jdbc,
			BufferedReader in) {
		Player player = null;
		String strUser = null;

		try {
			strUser = in.readLine();
		} catch (IOException e) {
			jibsServer.logException(e);
		}

		if (strUser != null) {
			StringTokenizer stoken = new StringTokenizer(strUser);
			String[] MyArgs = new String[5];
			int i = 0;

			while (stoken.hasMoreTokens()) {
				String String_Token = stoken.nextToken();

				if (String_Token.equals("login")) {
					MyArgs[0] = "login";
					i = 1;
				} else if (i == 0) {
					MyArgs[0] = String_Token;
					i = 1;
				} else if (i >= 1) {
					MyArgs[i++] = String_Token;
				}
			}

			if ((i == 1) && MyArgs[0].equalsIgnoreCase("guest")) {
				NewUser_Command cmd = new NewUser_Command(jibsServer, in, out);

				player = cmd.createNewUser(jibsServer, server, client, "", null);

				if (player != null) {
					player.canCLIP(false);
				}

				return player;
			}

			if (i == 5) {
				// bypass password confirmation
				try {
					player = new Player(jibsServer, server, jdbc, out,
							MyArgs[1], Integer.parseInt(MyArgs[2]),
							MyArgs[3], MyArgs[4]);
				} catch (NumberFormatException e) {
					jibsServer.logException(e);

					return null;
				}

				player.canCLIP(true);
			} else {
				// normal password confirmation
				out.print("Password: ");
				out.flush();

				String strPassword = null;

				try {
					strPassword = in.readLine();
				} catch (IOException e1) {
					jibsServer.logException(e1);
				}

				player = new Player(jibsServer, server, jdbc, out, "-", -1,
						strUser, strPassword);
				player.canCLIP(false);
			}
		}

		return player;
	}

	public boolean execute(JibsServer jibsServer, Player player,
			String strArgs, String[] args) {
		return true;
	}
}
